using System.Collections.Generic;
using System.Linq;
using ItemRazorV2_3.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace ItemRazorV2_3.Pages.Item
{
    public class GetAllItemsModel : PageModel
    {
        private ItemService _itemService;

        public List<Models.Item> Items { get; private set; }

        [BindProperty] public string SearchString { get; set; }
        [BindProperty] public int MaxPrice { get; set; }
        [BindProperty] public int MinPrice { get; set; }

        public GetAllItemsModel(ItemService itemService) //Dependency Injection
        {
            this._itemService = itemService;
        }
        public void OnGet()
        {
            Items = _itemService.GetItems(); ;
        }

        public IActionResult OnPostNameSearch()
        {
            Items = _itemService.NameSearch(SearchString).ToList();
            return Page();
        }

        public IActionResult OnPostPriceFilter(int maxPrice, int minPrice = 0)
        {
            Items = _itemService.PriceFilter(maxPrice, minPrice).ToList();
            return Page();
        }
    }
}
